diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/spectrum/model/three-gpp-channel-model.cc ns-3.47/src/spectrum/model/three-gpp-channel-model.cc
--- ns-3.46/src/spectrum/model/three-gpp-channel-model.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/spectrum/model/three-gpp-channel-model.cc	2026-02-16 16:08:49.824230700 -0800
@@ -2985,260 +3037,950 @@
         }
     }
 
-    DoubleVector attenuationDb;
+    (*clusterAngles)[AOA_INDEX] = clusterAoa;
+    (*clusterAngles)[AOD_INDEX] = clusterAod;
+    (*clusterAngles)[ZOA_INDEX] = clusterZoa;
+    (*clusterAngles)[ZOD_INDEX] = clusterZod;
+}
+
+void
+ThreeGppChannelModel::UpdateClusterDelay(DoubleVector* clusterDelay,
+                                         DoubleVector* delayConsistency,
+                                         Ptr<const ThreeGppChannelParams> channelParams) const
+{
+    NS_LOG_FUNCTION(this);
+
+    clusterDelay->clear();
+    clusterDelay->resize(channelParams->m_reducedClusterNumber);
+
+    NS_ASSERT(channelParams->m_delayConsistency.empty() == false);
+    NS_ASSERT(Simulator::Now() != channelParams->m_generatedTime);
+
+    // update cluster delays based on equation (7.6-9)
+    for (size_t cInd = 0; cInd < channelParams->m_reducedClusterNumber; cInd++)
+    {
+        const double timeSeconds = (Simulator::Now() - channelParams->m_generatedTime).GetSeconds();
+
+        (*delayConsistency)[cInd] -=
+            (sin(channelParams->m_angle.at(ZOA_INDEX).at(cInd) * M_PI / 180) *
+                 cos(channelParams->m_angle.at(AOA_INDEX).at(cInd) * M_PI / 180) *
+                 channelParams->m_rxSpeed.x +
+             sin(channelParams->m_angle.at(ZOA_INDEX).at(cInd) * M_PI / 180) *
+                 sin(channelParams->m_angle.at(AOA_INDEX).at(cInd) * M_PI / 180) *
+                 channelParams->m_rxSpeed.y +
+             (sin(channelParams->m_angle.at(ZOD_INDEX).at(cInd) * M_PI / 180) *
+                  cos(channelParams->m_angle.at(AOD_INDEX).at(cInd) * M_PI / 180) *
+                  channelParams->m_txSpeed.x +
+              sin(channelParams->m_angle.at(ZOD_INDEX).at(cInd) * M_PI / 180) *
+                  sin(channelParams->m_angle.at(AOD_INDEX).at(cInd) * M_PI / 180) *
+                  channelParams->m_txSpeed.y)) /
+            3e8 * timeSeconds;
+    }
+
+    // normalize the delays by removing the min value (7.6-10a)
+    double minTau = std::numeric_limits<double>::max();
+    for (size_t cInd = 0; cInd < channelParams->m_reducedClusterNumber; cInd++)
+    {
+        if (minTau > (*delayConsistency)[cInd])
+        {
+            minTau = (*delayConsistency)[cInd];
+        }
+    }
+
+    for (size_t cInd = 0; cInd < channelParams->m_reducedClusterNumber; cInd++)
+    {
+        // normalize the updated cluster delay (7.6-10a), and then use these cluster delays to
+        // generate cluster powers
+        (*clusterDelay)[cInd] = (*delayConsistency)[cInd] - minTau;
+    }
+}
+
+Vector
+ThreeGppChannelModel::ApplyVelocityRotation(const double alphaRad,
+                                            const double betaRad,
+                                            const double gammaRad,
+                                            const double etaRad,
+                                            const Vector& speed,
+                                            const int Xn) const
+{
+    NS_LOG_FUNCTION(this);
+    // only x and y components are used, no need to calculate the z component
+    const double sinAlpha = sin(alphaRad);
+    const double cosAlpha = cos(alphaRad);
+    const double sinBeta = sin(betaRad);
+    const double cosBeta = cos(betaRad);
+    const double sinGamma = sin(gammaRad);
+    const double cosGamma = cos(gammaRad);
+    const double sinEta = sin(etaRad);
+    const double cosEta = cos(etaRad);
+
+    Vector vRotated;
+
+    vRotated.x = (cosAlpha * cosBeta * cosGamma * cosEta - sinAlpha * sinEta * Xn -
+                  cosAlpha * sinBeta * sinGamma * cosEta) *
+                     speed.x +
+                 (-1 * cosAlpha * cosBeta * cosGamma * sinEta - sinAlpha * cosEta * Xn +
+                  cosAlpha * sinBeta * sinGamma * sinEta) *
+                     speed.y;
+
+    vRotated.y = (sinAlpha * cosBeta * cosGamma * cosEta + cosAlpha * sinEta * Xn -
+                  sinAlpha * sinBeta * sinGamma * cosEta) *
+                     speed.x +
+                 (-1 * sinAlpha * cosBeta * cosGamma * sinEta + cosAlpha * cosEta * Xn +
+                  sinAlpha * sinBeta * sinGamma * sinEta) *
+                     speed.y;
+
+    vRotated.z = 0;
+
+    return vRotated;
+}
+
+void
+ThreeGppChannelModel::UpdateClusterAngles(Ptr<const ThreeGppChannelParams> channelParams,
+                                          Double2DVector* clusterAngles,
+                                          const DoubleVector& prevClusterDelay) const
+{
+    NS_LOG_FUNCTION(this);
+    NS_ASSERT(prevClusterDelay.size() == channelParams->m_reducedClusterNumber);
+    const DoubleVector prevClusterAoa = channelParams->m_angle[AOA_INDEX];
+    const DoubleVector prevClusterZoa = channelParams->m_angle[ZOA_INDEX];
+    const DoubleVector prevClusterAod = channelParams->m_angle[AOD_INDEX];
+    const DoubleVector prevClusterZod = channelParams->m_angle[ZOD_INDEX];
+    const auto rxSpeed = channelParams->m_rxSpeed;
+    const auto txSpeed = channelParams->m_txSpeed;
+    const bool los = channelParams->m_losCondition == ChannelCondition::LOS;
+
+    for (size_t cInd = 0; cInd < prevClusterDelay.size(); cInd++)
+    {
+        // compute cluster relative speed
+        Vector vPrimeRx;
+        Vector vPrimeTx;
+        if (los)
+        {
+            vPrimeRx = rxSpeed - txSpeed; // (7.6-10b)
+            vPrimeTx = txSpeed - rxSpeed; // (7.6-10c)
+        }
+        else
+        {
+            NS_ASSERT(channelParams->m_clusterXnNlosSign.empty() == false);
+            NS_ASSERT(channelParams->m_clusterXnNlosSign.size() ==
+                      channelParams->m_reducedClusterNumber);
+            const int Xn = channelParams->m_clusterXnNlosSign[cInd];
+            double alphaRad = M_PI + DegreesToRadians(prevClusterAod[cInd]);
+            const double betaRad = M_PI / 2 - DegreesToRadians(prevClusterZod[cInd]);
+            const double gammaRad = M_PI / 2 - DegreesToRadians(prevClusterZoa[cInd]);
+            double etaRad = -1 * DegreesToRadians(prevClusterAoa[cInd]);
+
+            Vector rxSpeedPrime =
+                ApplyVelocityRotation(alphaRad, betaRad, gammaRad, etaRad, rxSpeed, Xn);
+
+            alphaRad = -1 * DegreesToRadians(prevClusterAod[cInd]);
+            etaRad = M_PI + DegreesToRadians(prevClusterAoa[cInd]);
+
+            Vector txSpeedPrime =
+                ApplyVelocityRotation(alphaRad, betaRad, gammaRad, etaRad, txSpeed, Xn);
+            vPrimeRx = rxSpeedPrime - txSpeed; // (7.6-10b)
+            vPrimeTx = txSpeedPrime - rxSpeed; // (7.6-10c)
+        }
+
+        using DPV = std::vector<std::pair<double, double>>;
+        const auto& cachedAngleSincos = channelParams->m_cachedAngleSincos;
+        const DPV& zoaSinCos = cachedAngleSincos[ZOA_INDEX];
+        const DPV& zodSinCos = cachedAngleSincos[ZOD_INDEX];
+        const DPV& aoaSinCos = cachedAngleSincos[AOA_INDEX];
+        const DPV& aodSinCos = cachedAngleSincos[AOD_INDEX];
+
+        const double deltaT =
+            Simulator::Now().GetSeconds() - channelParams->m_generatedTime.GetSeconds();
+
+        // update the angles according to equations (7.6-11) - (7.6-14)
+        (*clusterAngles)[AOD_INDEX][cInd] =
+            prevClusterAod[cInd] +
+            RadiansToDegrees(
+                (-aodSinCos[cInd].first * vPrimeRx.x + aodSinCos[cInd].second * vPrimeRx.y) /
+                (3e8 * prevClusterDelay[cInd] * zodSinCos[cInd].first) * deltaT);
+
+        (*clusterAngles)[ZOD_INDEX][cInd] =
+            prevClusterZod[cInd] +
+            RadiansToDegrees((zodSinCos[cInd].second * aodSinCos[cInd].second * vPrimeRx.x +
+                              zodSinCos[cInd].second * -aodSinCos[cInd].first * vPrimeRx.y) /
+                             (3e8 * prevClusterDelay[cInd]) * deltaT);
+
+        (*clusterAngles)[AOA_INDEX][cInd] =
+            prevClusterAoa[cInd] +
+            RadiansToDegrees(
+                (-aoaSinCos[cInd].first * vPrimeTx.x + aoaSinCos[cInd].second * vPrimeTx.y) /
+                (3e8 * prevClusterDelay[cInd] * zoaSinCos[cInd].first) * deltaT);
+
+        (*clusterAngles)[ZOA_INDEX][cInd] =
+            prevClusterZoa[cInd] +
+            RadiansToDegrees((zoaSinCos[cInd].second * aoaSinCos[cInd].second * vPrimeTx.x +
+                              zoaSinCos[cInd].second * aoaSinCos[cInd].first * vPrimeTx.y) /
+                             (3e8 * prevClusterDelay[cInd]) * deltaT);
+    }
+
+    NS_LOG_DEBUG("Cluster angles updated");
+}
+
+void
+ThreeGppChannelModel::ApplyAttenuationToClusterPowers(
+    Double2DVector* nonSelfBlocking,
+    DoubleVector* clusterPowers,
+    DoubleVector* attenuation_dB,
+    Ptr<const ThreeGppChannelParams> channelParams,
+    const DoubleVector& clusterAoa,
+    const DoubleVector& clusterZoa,
+    Ptr<const ParamsTable> table3gpp) const
+{
+    NS_LOG_FUNCTION(this);
+
     if (m_blockage)
     {
-        attenuationDb = CalcAttenuationOfBlockage(channelParams, clusterAoa, clusterZoa);
+        CalcAttenuationOfBlockage(nonSelfBlocking,
+                                  attenuation_dB,
+                                  channelParams,
+                                  clusterAoa,
+                                  clusterZoa,
+                                  table3gpp);
         for (uint8_t cInd = 0; cInd < channelParams->m_reducedClusterNumber; cInd++)
         {
-            channelParams->m_clusterPower[cInd] =
-                channelParams->m_clusterPower[cInd] / pow(10, attenuationDb[cInd] / 10.0);
+            (*clusterPowers)[cInd] =
+                (*clusterPowers)[cInd] / pow(10, (*attenuation_dB)[cInd] / 10.0);
         }
     }
     else
     {
-        attenuationDb.push_back(0);
+        attenuation_dB->push_back(0);
     }
+}
 
-    // store attenuation
-    channelParams->m_attenuation_dB = attenuationDb;
+void
+ThreeGppChannelModel::ComputeRayAngles(Ptr<const ThreeGppChannelParams> channelParams,
+                                       Ptr<const ParamsTable> table3gpp,
+                                       Double2DVector* rayAoaRadian,
+                                       Double2DVector* rayAodRadian,
+                                       Double2DVector* rayZoaRadian,
+                                       Double2DVector* rayZodRadian) const
+{
+    NS_LOG_FUNCTION(this);
 
-    // Step 8: Coupling of rays within a cluster for both azimuth and elevation
-    // shuffle all the arrays to perform random coupling
-    MatrixBasedChannelModel::Double2DVector rayAoaRadian(
-        channelParams->m_reducedClusterNumber,
-        DoubleVector(table3gpp->m_raysPerCluster,
-                     0)); // rayAoaRadian[n][m], where n is cluster index, m is ray index
-    MatrixBasedChannelModel::Double2DVector rayAodRadian(
-        channelParams->m_reducedClusterNumber,
-        DoubleVector(table3gpp->m_raysPerCluster,
-                     0)); // rayAodRadian[n][m], where n is cluster index, m is ray index
-    MatrixBasedChannelModel::Double2DVector rayZoaRadian(
-        channelParams->m_reducedClusterNumber,
-        DoubleVector(table3gpp->m_raysPerCluster,
-                     0)); // rayZoaRadian[n][m], where n is cluster index, m is ray index
-    MatrixBasedChannelModel::Double2DVector rayZodRadian(
-        channelParams->m_reducedClusterNumber,
-        DoubleVector(table3gpp->m_raysPerCluster,
-                     0)); // rayZodRadian[n][m], where n is cluster index, m is ray index
+    const DoubleVector& clusterAoa = channelParams->m_angle[AOA_INDEX];
+    const DoubleVector& clusterAod = channelParams->m_angle[AOD_INDEX];
+    const DoubleVector& clusterZoa = channelParams->m_angle[ZOA_INDEX];
+    const DoubleVector& clusterZod = channelParams->m_angle[ZOD_INDEX];
+
+    // Resize/initialize containers: [numClusters][raysPerCluster]
+    *rayAoaRadian = Double2DVector(channelParams->m_reducedClusterNumber,
+                                   DoubleVector(table3gpp->m_raysPerCluster, 0));
+    *rayAodRadian = Double2DVector(channelParams->m_reducedClusterNumber,
+                                   DoubleVector(table3gpp->m_raysPerCluster, 0));
+    *rayZoaRadian = Double2DVector(channelParams->m_reducedClusterNumber,
+                                   DoubleVector(table3gpp->m_raysPerCluster, 0));
+    *rayZodRadian = Double2DVector(channelParams->m_reducedClusterNumber,
+                                   DoubleVector(table3gpp->m_raysPerCluster, 0));
+
+    const double pow10_uLgZSD = std::pow(10.0, table3gpp->m_uLgZSD);
 
-    const double pow10_uLgZSD = pow(10, table3gpp->m_uLgZSD);
+    // NOTE: offSetAlpha[m] must be available in scope (same as previous implementation)
     for (uint8_t nInd = 0; nInd < channelParams->m_reducedClusterNumber; nInd++)
     {
         for (uint8_t mInd = 0; mInd < table3gpp->m_raysPerCluster; mInd++)
         {
-            double tempAoa = clusterAoa[nInd] + table3gpp->m_cASA * offSetAlpha[mInd]; //(7.5-13)
-            double tempZoa = clusterZoa[nInd] + table3gpp->m_cZSA * offSetAlpha[mInd]; //(7.5-18)
-            std::tie(rayAoaRadian[nInd][mInd], rayZoaRadian[nInd][mInd]) =
+            const double tempAoa =
+                clusterAoa[nInd] + table3gpp->m_cASA * offSetAlpha[mInd]; // (7.5-13)
+            const double tempZoa =
+                clusterZoa[nInd] + table3gpp->m_cZSA * offSetAlpha[mInd]; // (7.5-18)
+            std::tie((*rayAoaRadian)[nInd][mInd], (*rayZoaRadian)[nInd][mInd]) =
                 WrapAngles(DegreesToRadians(tempAoa), DegreesToRadians(tempZoa));
 
-            double tempAod = clusterAod[nInd] + table3gpp->m_cASD * offSetAlpha[mInd];    //(7.5-13)
-            double tempZod = clusterZod[nInd] + 0.375 * pow10_uLgZSD * offSetAlpha[mInd]; //(7.5-20)
-            std::tie(rayAodRadian[nInd][mInd], rayZodRadian[nInd][mInd]) =
+            const double tempAod =
+                clusterAod[nInd] + table3gpp->m_cASD * offSetAlpha[mInd]; // (7.5-13)
+            const double tempZod = clusterZod[nInd] + 0.375 * pow10_uLgZSD * offSetAlpha[mInd];
+            // (7.5-20)
+            std::tie((*rayAodRadian)[nInd][mInd], (*rayZodRadian)[nInd][mInd]) =
                 WrapAngles(DegreesToRadians(tempAod), DegreesToRadians(tempZod));
         }
     }
+}
 
+void
+ThreeGppChannelModel::RandomRaysCoupling(Ptr<const ThreeGppChannelParams> channelParams,
+                                         Double2DVector* rayAoaRadian,
+                                         Double2DVector* rayAodRadian,
+                                         Double2DVector* rayZoaRadian,
+                                         Double2DVector* rayZodRadian) const
+{
+    NS_LOG_FUNCTION(this);
     for (uint8_t cIndex = 0; cIndex < channelParams->m_reducedClusterNumber; cIndex++)
     {
-        Shuffle(rayAodRadian[cIndex].begin(), rayAodRadian[cIndex].end(), m_uniformRvShuffle);
-        Shuffle(rayAoaRadian[cIndex].begin(), rayAoaRadian[cIndex].end(), m_uniformRvShuffle);
-        Shuffle(rayZodRadian[cIndex].begin(), rayZodRadian[cIndex].end(), m_uniformRvShuffle);
-        Shuffle(rayZoaRadian[cIndex].begin(), rayZoaRadian[cIndex].end(), m_uniformRvShuffle);
+        Shuffle((*rayAodRadian)[cIndex].begin(), (*rayAodRadian)[cIndex].end(), m_uniformRvShuffle);
+        Shuffle((*rayAoaRadian)[cIndex].begin(), (*rayAoaRadian)[cIndex].end(), m_uniformRvShuffle);
+        Shuffle((*rayZodRadian)[cIndex].begin(), (*rayZodRadian)[cIndex].end(), m_uniformRvShuffle);
+        Shuffle((*rayZoaRadian)[cIndex].begin(), (*rayZoaRadian)[cIndex].end(), m_uniformRvShuffle);
     }
+}
 
-    // store values
-    channelParams->m_rayAodRadian = rayAodRadian;
-    channelParams->m_rayAoaRadian = rayAoaRadian;
-    channelParams->m_rayZodRadian = rayZodRadian;
-    channelParams->m_rayZoaRadian = rayZoaRadian;
-
-    // Step 9: Generate the cross polarization power ratios
-    // Step 10: Draw initial phases
-
-    // vector containing the cross polarization power ratios, as defined by 7.5-21
-    auto& crossPolarizationPowerRatios = channelParams->m_crossPolarizationPowerRatios;
-    // rayAoaRadian[n][m], where n is cluster index, m is ray index
-    auto& clusterPhase = channelParams->m_clusterPhase;
+void
+ThreeGppChannelModel::GenerateCrossPolPowerRatiosAndInitialPhases(
+    Double2DVector* crossPolarizationPowerRatios,
+    Double3DVector* clusterPhase,
+    const uint8_t reducedClusterNumber,
+    Ptr<const ParamsTable> table3gpp) const
+{
+    // a vector containing the cross-polarization power ratios, as defined by 7.5-21
+    // store the PHI values for all the possible combination of polarizations
+    clusterPhase->clear();
+    clusterPhase->resize(reducedClusterNumber);
+    crossPolarizationPowerRatios->clear();
+    crossPolarizationPowerRatios->resize(reducedClusterNumber);
 
     const double uXprLinear = pow(10, table3gpp->m_uXpr / 10.0);     // convert to linear
     const double sigXprLinear = pow(10, table3gpp->m_sigXpr / 10.0); // convert to linear
 
-    // store the PHI values for all the possible combination of polarization
-    clusterPhase.resize(channelParams->m_reducedClusterNumber);
-    crossPolarizationPowerRatios.resize(channelParams->m_reducedClusterNumber);
-    for (uint8_t nInd = 0; nInd < channelParams->m_reducedClusterNumber; nInd++)
+    for (uint8_t clusterIndex = 0; clusterIndex < reducedClusterNumber; clusterIndex++)
     {
-        clusterPhase[nInd].resize(table3gpp->m_raysPerCluster);
-        crossPolarizationPowerRatios[nInd].resize(table3gpp->m_raysPerCluster);
-        for (uint8_t mInd = 0; mInd < table3gpp->m_raysPerCluster; mInd++)
-        {
-            clusterPhase[nInd][mInd].resize(4);
-            // used to store the XPR values
-            crossPolarizationPowerRatios[nInd][mInd] =
+        (*clusterPhase)[clusterIndex].resize(table3gpp->m_raysPerCluster);
+        (*crossPolarizationPowerRatios)[clusterIndex].resize(table3gpp->m_raysPerCluster);
+        for (uint8_t rayIndex = 0; rayIndex < table3gpp->m_raysPerCluster; rayIndex++)
+        {
+            (*clusterPhase)[clusterIndex][rayIndex].resize(4);
+            // stores the XPR values
+            (*crossPolarizationPowerRatios)[clusterIndex][rayIndex] =
                 std::pow(10, (m_normalRv->GetValue() * sigXprLinear + uXprLinear) / 10.0);
-            for (uint8_t pInd = 0; pInd < 4; pInd++)
+            for (uint8_t polIndex = 0; polIndex < 4; polIndex++)
             {
-                // used to store the PHI values
-                clusterPhase[nInd][mInd][pInd] = m_uniformRv->GetValue(-1 * M_PI, M_PI);
+                // stores the PHI values
+                (*clusterPhase)[clusterIndex][rayIndex][polIndex] =
+                    m_uniformRv->GetValue(-1 * M_PI, M_PI);
             }
         }
     }
+}
 
-    uint8_t cluster1st = 0;
-    uint8_t cluster2nd = 0; // first and second strongest cluster;
-    double maxPower = 0;
-    for (uint8_t cIndex = 0; cIndex < channelParams->m_reducedClusterNumber; cIndex++)
+void
+ThreeGppChannelModel::FindStrongestClusters(Ptr<const ThreeGppChannelParams> channelParams,
+                                            Ptr<const ParamsTable> table3gpp,
+                                            uint8_t* cluster1st,
+                                            uint8_t* cluster2nd,
+                                            DoubleVector* clusterDelay,
+                                            Double2DVector* angles,
+                                            DoubleVector* alpha,
+                                            DoubleVector* dTerm,
+                                            DoubleVector* clusterPower) const
+
+{
+    NS_LOG_FUNCTION(this);
+    NS_ABORT_IF(table3gpp == nullptr);
+    NS_ABORT_IF(channelParams == nullptr);
+    NS_ABORT_IF(cluster1st == nullptr || cluster2nd == nullptr);
+    NS_ABORT_IF(clusterDelay == nullptr || angles == nullptr || alpha == nullptr ||
+                dTerm == nullptr);
+    NS_ABORT_IF(angles->size() != ZOD_INDEX + 1); // expects 4 directions: AOA/AOD/ZOA/ZOD
+    NS_ABORT_IF(channelParams->m_reducedClusterNumber == 0);
+    NS_ABORT_IF(channelParams->m_clusterPower.size() != channelParams->m_reducedClusterNumber);
+    NS_ABORT_IF(alpha->size() != channelParams->m_reducedClusterNumber);
+    NS_ABORT_IF(dTerm->size() != channelParams->m_reducedClusterNumber);
+    NS_ABORT_IF(clusterDelay->size() != channelParams->m_reducedClusterNumber);
+
+    for (auto dir : {AOA_INDEX, AOD_INDEX, ZOA_INDEX, ZOD_INDEX})
+    {
+        NS_ABORT_IF((*angles)[dir].size() != channelParams->m_reducedClusterNumber);
+    }
+
+    *cluster1st = 0;
+    *cluster2nd = 0;
+
+    if (channelParams->m_reducedClusterNumber > 1)
     {
-        if (maxPower < channelParams->m_clusterPower[cIndex])
+        // Find strongest
+        double maxPower = channelParams->m_clusterPower[0];
+        for (uint8_t cIndex = 1; cIndex < channelParams->m_reducedClusterNumber; cIndex++)
+        {
+            if (maxPower < channelParams->m_clusterPower[cIndex])
+            {
+                maxPower = channelParams->m_clusterPower[cIndex];
+                *cluster1st = cIndex;
+            }
+        }
+        // Initialize second-strongest to "some other index"
+        *cluster2nd = (*cluster1st == 0) ? 1 : 0;
+        maxPower = channelParams->m_clusterPower[*cluster2nd];
+
+        // Find second-strongest (must be != cluster1st)
+        for (uint8_t cIndex = 0; cIndex < channelParams->m_reducedClusterNumber; cIndex++)
         {
-            maxPower = channelParams->m_clusterPower[cIndex];
-            cluster1st = cIndex;
+            if (cIndex != *cluster1st && maxPower < channelParams->m_clusterPower[cIndex])
+            {
+                maxPower = channelParams->m_clusterPower[cIndex];
+                *cluster2nd = cIndex;
+            }
         }
     }
-    channelParams->m_cluster1st = cluster1st;
-    maxPower = 0;
-    for (uint8_t cIndex = 0; cIndex < channelParams->m_reducedClusterNumber; cIndex++)
+    NS_ABORT_IF(channelParams->m_reducedClusterNumber > 1 && *cluster1st == *cluster2nd);
+    NS_LOG_INFO("1st strongest cluster:" << +*cluster1st
+                                         << ", 2nd strongest cluster:" << +*cluster2nd);
+
+    // store the values for the subclusters
+    if (*cluster1st == *cluster2nd)
+    {
+        clusterDelay->push_back((*clusterDelay)[*cluster1st] + 1.28 * table3gpp->m_cDS);
+        clusterDelay->push_back((*clusterDelay)[*cluster1st] + 2.56 * table3gpp->m_cDS);
+
+        for (auto dir : {AOA_INDEX, AOD_INDEX, ZOA_INDEX, ZOD_INDEX})
+        {
+            auto& v = (*angles)[dir];
+            v.push_back(v[*cluster1st]);
+            v.push_back(v[*cluster1st]);
+        }
+
+        alpha->push_back((*alpha)[*cluster1st]);
+        alpha->push_back((*alpha)[*cluster1st]);
+        dTerm->push_back((*dTerm)[*cluster1st]);
+        dTerm->push_back((*dTerm)[*cluster1st]);
+        clusterPower->push_back((*clusterPower)[*cluster1st]);
+        clusterPower->push_back((*clusterPower)[*cluster1st]);
+    }
+    else
     {
-        if (maxPower < channelParams->m_clusterPower[cIndex] && cluster1st != cIndex)
+        const uint8_t min = std::min(*cluster1st, *cluster2nd);
+        const uint8_t max = std::max(*cluster1st, *cluster2nd);
+
+        clusterDelay->push_back((*clusterDelay)[min] + 1.28 * table3gpp->m_cDS);
+        clusterDelay->push_back((*clusterDelay)[min] + 2.56 * table3gpp->m_cDS);
+        clusterDelay->push_back((*clusterDelay)[max] + 1.28 * table3gpp->m_cDS);
+        clusterDelay->push_back((*clusterDelay)[max] + 2.56 * table3gpp->m_cDS);
+
+        for (auto dir : {AOA_INDEX, AOD_INDEX, ZOA_INDEX, ZOD_INDEX})
         {
-            maxPower = channelParams->m_clusterPower[cIndex];
-            cluster2nd = cIndex;
+            auto& v = (*angles)[dir];
+            v.push_back(v[min]);
+            v.push_back(v[min]);
+            v.push_back(v[max]);
+            v.push_back(v[max]);
         }
+
+        alpha->push_back((*alpha)[min]);
+        alpha->push_back((*alpha)[min]);
+        alpha->push_back((*alpha)[max]);
+        alpha->push_back((*alpha)[max]);
+
+        dTerm->push_back((*dTerm)[min]);
+        dTerm->push_back((*dTerm)[min]);
+        dTerm->push_back((*dTerm)[max]);
+        dTerm->push_back((*dTerm)[max]);
+
+        clusterPower->push_back((*clusterPower)[min]);
+        clusterPower->push_back((*clusterPower)[min]);
+        clusterPower->push_back((*clusterPower)[max]);
+        clusterPower->push_back((*clusterPower)[max]);
     }
-    channelParams->m_cluster2nd = cluster2nd;
 
-    NS_LOG_INFO("1st strongest cluster:" << +cluster1st
-                                         << ", 2nd strongest cluster:" << +cluster2nd);
+    const std::size_t expectedExtra = (*cluster1st == *cluster2nd) ? 2u : 4u;
+    const std::size_t expectedSize =
+        static_cast<std::size_t>(channelParams->m_reducedClusterNumber) + expectedExtra;
 
-    // store the delays and the angles for the subclusters
-    if (cluster1st == cluster2nd)
+    NS_ABORT_IF(clusterDelay->size() != expectedSize);
+    NS_ABORT_IF(alpha->size() != expectedSize);
+    NS_ABORT_IF(dTerm->size() != expectedSize);
+    for (auto dir : {AOA_INDEX, AOD_INDEX, ZOA_INDEX, ZOD_INDEX})
     {
-        clusterDelay.push_back(clusterDelay[cluster1st] + 1.28 * table3gpp->m_cDS);
-        clusterDelay.push_back(clusterDelay[cluster1st] + 2.56 * table3gpp->m_cDS);
-
-        clusterAoa.push_back(clusterAoa[cluster1st]);
-        clusterAoa.push_back(clusterAoa[cluster1st]);
+        NS_ABORT_IF((*angles)[dir].size() != expectedSize);
+    }
+}
 
-        clusterZoa.push_back(clusterZoa[cluster1st]);
-        clusterZoa.push_back(clusterZoa[cluster1st]);
+void
+ThreeGppChannelModel::TrimToBaseClusters(
+    const uint8_t reducedClusterNumber,
+    DoubleVector* delay,
+    Double2DVector* angles,
+    std::vector<std::vector<std::pair<double, double>>>* cachedAngleSincos,
+    DoubleVector* alpha,
+    DoubleVector* dTerm,
+    DoubleVector* clusterPower) const
+{
+    NS_LOG_FUNCTION(this);
+    NS_ABORT_IF(delay == nullptr || angles == nullptr);
+    NS_ABORT_IF(angles->size() != ZOD_INDEX + 1); // expects 4 directions: AOA/ZOA/AOD/ZOD
 
-        clusterAod.push_back(clusterAod[cluster1st]);
-        clusterAod.push_back(clusterAod[cluster1st]);
+    const auto totalClusterNumber = delay->size();
+    if (reducedClusterNumber == totalClusterNumber)
+    {
+        NS_LOG_DEBUG("Nothing to trim, the reduced cluster number is equal to the vector of "
+                     "per cluster delays");
+        return; // already trimmed
+    }
+    NS_ABORT_IF(totalClusterNumber < reducedClusterNumber);
+    const auto extraClusters = totalClusterNumber - reducedClusterNumber;
+    NS_ABORT_MSG_IF(!(extraClusters == 2 || extraClusters == 4),
+                    "The number of extra clusters to be removed can be either 2 or 4.");
+    // Trim delay
+    delay->erase(delay->end() - extraClusters, delay->end());
 
-        clusterZod.push_back(clusterZod[cluster1st]);
-        clusterZod.push_back(clusterZod[cluster1st]);
+    // Trim angles
+    for (auto dir : {AOA_INDEX, ZOA_INDEX, AOD_INDEX, ZOD_INDEX})
+    {
+        NS_ABORT_IF((*angles)[dir].size() != totalClusterNumber);
+        (*angles)[dir].erase((*angles)[dir].end() - extraClusters, (*angles)[dir].end());
     }
-    else
+
+    // Trim cached sin/cos angles (used by Doppler)
+    if (cachedAngleSincos && !cachedAngleSincos->empty())
     {
-        double min;
-        double max;
-        if (cluster1st < cluster2nd)
-        {
-            min = cluster1st;
-            max = cluster2nd;
-        }
-        else
+        for (auto dir : {AOA_INDEX, ZOA_INDEX, AOD_INDEX, ZOD_INDEX})
         {
-            min = cluster2nd;
-            max = cluster1st;
+            NS_ABORT_IF((*cachedAngleSincos)[dir].size() != totalClusterNumber);
+            (*cachedAngleSincos)[dir].erase((*cachedAngleSincos)[dir].end() - extraClusters,
+                                            (*cachedAngleSincos)[dir].end());
         }
-        clusterDelay.push_back(clusterDelay[min] + 1.28 * table3gpp->m_cDS);
-        clusterDelay.push_back(clusterDelay[min] + 2.56 * table3gpp->m_cDS);
-        clusterDelay.push_back(clusterDelay[max] + 1.28 * table3gpp->m_cDS);
-        clusterDelay.push_back(clusterDelay[max] + 2.56 * table3gpp->m_cDS);
-
-        clusterAoa.push_back(clusterAoa[min]);
-        clusterAoa.push_back(clusterAoa[min]);
-        clusterAoa.push_back(clusterAoa[max]);
-        clusterAoa.push_back(clusterAoa[max]);
-
-        clusterZoa.push_back(clusterZoa[min]);
-        clusterZoa.push_back(clusterZoa[min]);
-        clusterZoa.push_back(clusterZoa[max]);
-        clusterZoa.push_back(clusterZoa[max]);
-
-        clusterAod.push_back(clusterAod[min]);
-        clusterAod.push_back(clusterAod[min]);
-        clusterAod.push_back(clusterAod[max]);
-        clusterAod.push_back(clusterAod[max]);
-
-        clusterZod.push_back(clusterZod[min]);
-        clusterZod.push_back(clusterZod[min]);
-        clusterZod.push_back(clusterZod[max]);
-        clusterZod.push_back(clusterZod[max]);
-    }
-
-    channelParams->m_delay = clusterDelay;
-    channelParams->m_angle.clear();
-    channelParams->m_angle.push_back(clusterAoa);
-    channelParams->m_angle.push_back(clusterZoa);
-    channelParams->m_angle.push_back(clusterAod);
-    channelParams->m_angle.push_back(clusterZod);
+    }
 
-    // Precompute angles sincos
-    channelParams->m_cachedAngleSincos.resize(channelParams->m_angle.size());
+    // Trim Doppler terms
+    if (alpha && !alpha->empty())
+    {
+        NS_ABORT_IF(alpha->size() != totalClusterNumber);
+        alpha->erase(alpha->end() - extraClusters, alpha->end());
+    }
+    if (dTerm && !dTerm->empty())
+    {
+        NS_ABORT_IF(dTerm->size() != totalClusterNumber);
+        dTerm->erase(dTerm->end() - extraClusters, dTerm->end());
+    }
+
+    NS_ABORT_IF(delay->size() != reducedClusterNumber);
+    for (auto dir : {AOA_INDEX, ZOA_INDEX, AOD_INDEX, ZOD_INDEX})
+    {
+        NS_ABORT_IF((*angles)[dir].size() != reducedClusterNumber);
+    }
+
+    // Trim cluster powers
+    if (clusterPower && !clusterPower->empty())
+    {
+        NS_ABORT_IF(clusterPower->size() != totalClusterNumber);
+        clusterPower->erase(clusterPower->end() - extraClusters, clusterPower->end());
+    }
+}
+
+void
+ThreeGppChannelModel::PrecomputeAnglesSinCos(
+    Ptr<const ThreeGppChannelParams> channelParams,
+    std::vector<std::vector<std::pair<double, double>>>* cachedAngleSinCos) const
+{
+    NS_LOG_FUNCTION(this);
+    cachedAngleSinCos->resize(channelParams->m_angle.size());
     for (size_t direction = 0; direction < channelParams->m_angle.size(); direction++)
     {
-        channelParams->m_cachedAngleSincos[direction].resize(
-            channelParams->m_angle[direction].size());
+        (*cachedAngleSinCos)[direction].resize(channelParams->m_angle[direction].size());
         for (size_t cluster = 0; cluster < channelParams->m_angle[direction].size(); cluster++)
         {
-            channelParams->m_cachedAngleSincos[direction][cluster] = {
+            (*cachedAngleSinCos)[direction][cluster] = {
                 sin(channelParams->m_angle[direction][cluster] * DEG2RAD),
                 cos(channelParams->m_angle[direction][cluster] * DEG2RAD)};
         }
     }
+}
 
-    // Compute alpha and D as described in 3GPP TR 37.885 v15.3.0, Sec. 6.2.3
-    // These terms account for an additional Doppler contribution due to the
-    // presence of moving objects in the surrounding environment, such as in
-    // vehicular scenarios.
-    // This contribution is applied only to the delayed (reflected) paths and
-    // must be properly configured by setting the value of
-    // m_vScatt, which is defined as "maximum speed of the vehicle in the
-    // layout".
-    // By default, m_vScatt is set to 0, so there is no additional Doppler
-    // contribution.
-
-    DoubleVector dopplerTermAlpha;
-    DoubleVector dopplerTermD;
-
-    // 2 or 4 is added to account for additional subrays for the 1st and 2nd clusters, if there is
-    // only one cluster then would be added 2 more subrays (see creation of Husn channel matrix)
-    uint8_t updatedClusterNumber = (channelParams->m_reducedClusterNumber == 1)
-                                       ? channelParams->m_reducedClusterNumber + 2
-                                       : channelParams->m_reducedClusterNumber + 4;
-
-    for (uint8_t cIndex = 0; cIndex < updatedClusterNumber; cIndex++)
-    {
-        double alpha = 0;
-        double D = 0;
-        if (cIndex != 0)
-        {
-            alpha = m_uniformRvDoppler->GetValue(-1, 1);
-            D = m_uniformRvDoppler->GetValue(-m_vScatt, m_vScatt);
-        }
-        dopplerTermAlpha.push_back(alpha);
-        dopplerTermD.push_back(D);
+void
+ThreeGppChannelModel::GenerateDopplerTerms(const uint8_t reducedClusterNumber,
+                                           DoubleVector* dopplerTermAlpha,
+                                           DoubleVector* dopplerTermD) const
+{
+    NS_ABORT_IF(dopplerTermAlpha == nullptr || dopplerTermD == nullptr);
+    dopplerTermAlpha->assign(reducedClusterNumber, 0.0);
+    dopplerTermD->assign(reducedClusterNumber, 0.0);
+
+    for (uint8_t cIndex = 1; cIndex < reducedClusterNumber; ++cIndex)
+    {
+        (*dopplerTermAlpha)[cIndex] = m_uniformRvDoppler->GetValue(-1, 1);
+        (*dopplerTermD)[cIndex] = m_uniformRvDoppler->GetValue(-m_vScatt, m_vScatt);
+    }
+}
+
+double
+ThreeGppChannelModel::ComputeEndpointDisplacement2d(Ptr<const MobilityModel> aMob,
+                                                    Ptr<const MobilityModel> bMob,
+                                                    const Vector& lastPositionFirst,
+                                                    const Vector& lastPositionSecond) const
+
+{
+    Ptr<const MobilityModel> firstMob = aMob;
+    Ptr<const MobilityModel> secondMob = bMob;
+    if (aMob->GetObject<Node>()->GetId() > bMob->GetObject<Node>()->GetId())
+    {
+        std::swap(firstMob, secondMob);
+    }
+
+    const Vector posFirst = firstMob->GetPosition();
+    const Vector posSecond = secondMob->GetPosition();
+
+    const double dispFirst =
+        std::hypot(posFirst.x - lastPositionFirst.x, posFirst.y - lastPositionFirst.y);
+    const double dispSecond =
+        std::hypot(posSecond.x - lastPositionSecond.x, posSecond.y - lastPositionSecond.y);
+
+    return std::max(dispFirst, dispSecond);
+}
+
+void
+ThreeGppChannelModel::UpdateLinkGeometry(Ptr<const MobilityModel> aMob,
+                                         Ptr<const MobilityModel> bMob,
+                                         double* distance2D,
+                                         double* distance3D,
+                                         double* endpointDisplacement2D,
+                                         double* relativeDisplacement2D,
+                                         Vector* lastPositionFirst,
+                                         Vector* lastPositionSecond,
+                                         Vector2D* lastRelativePosition2D) const
+{
+    NS_LOG_FUNCTION(this);
+    NS_ASSERT(distance2D && distance3D && endpointDisplacement2D && relativeDisplacement2D &&
+              lastPositionFirst && lastPositionSecond && lastRelativePosition2D);
+
+    // Canonical ordering by node ID (min ID / max ID)
+    Ptr<const MobilityModel> firstMob = aMob;
+    Ptr<const MobilityModel> secondMob = bMob;
+    if (aMob->GetObject<Node>()->GetId() > bMob->GetObject<Node>()->GetId())
+    {
+        std::swap(firstMob, secondMob);
+    }
+
+    // Obtain the new positions
+    const Vector posFirst = firstMob->GetPosition();
+    const Vector posSecond = secondMob->GetPosition();
+
+    const double deltaX = posFirst.x - posSecond.x;
+    const double deltaY = posFirst.y - posSecond.y;
+
+    // Link 2D distance
+    *distance2D = std::hypot(deltaX, deltaY);
+
+    // Link 3D distance
+    const double deltaZ = posFirst.z - posSecond.z;
+    *distance3D = std::hypot(*distance2D, deltaZ);
+
+    // Relative (geometry) displacement: change in the canonical Tx-Rx position vector
+    const Vector2D relNow{deltaX, deltaY};
+    *relativeDisplacement2D = (relNow - *lastRelativePosition2D).GetLength();
+
+    // Endpoint displacement: max motion of the two endpoints since the last update
+    const double dispFirst =
+        std::hypot(posFirst.x - lastPositionFirst->x, posFirst.y - lastPositionFirst->y);
+    const double dispSecond =
+        std::hypot(posSecond.x - lastPositionSecond->x, posSecond.y - lastPositionSecond->y);
+    *endpointDisplacement2D = std::max(dispFirst, dispSecond);
+
+    NS_ASSERT(std::isfinite(*distance2D));
+    NS_ASSERT(std::isfinite(*distance3D));
+    NS_ASSERT(std::isfinite(*relativeDisplacement2D));
+    NS_ASSERT(std::isfinite(*endpointDisplacement2D));
+    NS_ASSERT(*distance2D >= 0.0);
+    NS_ASSERT(*distance3D >= 0.0);
+    NS_ASSERT(*relativeDisplacement2D >= 0.0);
+    NS_ASSERT(*endpointDisplacement2D >= 0.0);
+
+    // Store the new positions for next time (canonically ordered endpoints)
+    *lastPositionFirst = posFirst;
+    *lastPositionSecond = posSecond;
+    *lastRelativePosition2D = relNow;
+}
+
+Ptr<ThreeGppChannelModel::ThreeGppChannelParams>
+ThreeGppChannelModel::GenerateChannelParameters(Ptr<const ChannelCondition> channelCondition,
+                                                Ptr<const ParamsTable> table3gpp,
+                                                Ptr<const MobilityModel> aMob,
+                                                Ptr<const MobilityModel> bMob) const
+{
+    NS_LOG_FUNCTION(this);
+    // Enforce canonical ordering (by node id) for deterministic parameter generation.
+    Ptr<const MobilityModel> aMobOrdered = aMob;
+    Ptr<const MobilityModel> bMobOrdered = bMob;
+    const uint32_t idA = aMob->GetObject<Node>()->GetId();
+    const uint32_t idB = bMob->GetObject<Node>()->GetId();
+    if (idA > idB)
+    {
+        std::swap(aMobOrdered, bMobOrdered);
+    }
+
+    // Create new channel parameters instance
+    Ptr<ThreeGppChannelParams> channelParams = Create<ThreeGppChannelParams>();
+    // Set basic parameters
+    channelParams->m_generatedTime = Simulator::Now();
+    channelParams->m_nodeIds = {aMobOrdered->GetObject<Node>()->GetId(),
+                                bMobOrdered->GetObject<Node>()->GetId()};
+    channelParams->m_losCondition = channelCondition->GetLosCondition();
+    channelParams->m_o2iCondition = channelCondition->GetO2iCondition();
+    // Angles are generated with aMob as transmitter (departure) and bMob as receiver (arrival).
+    channelParams->m_txSpeed = aMobOrdered->GetVelocity();
+    channelParams->m_rxSpeed = bMobOrdered->GetVelocity();
+    UpdateLinkGeometry(aMobOrdered,
+                       bMobOrdered,
+                       &channelParams->m_dis2D,
+                       &channelParams->m_dis3D,
+                       &channelParams->m_endpointDisplacement2D,
+                       &channelParams->m_relativeDisplacement2D,
+                       &channelParams->m_lastPositionFirst,
+                       &channelParams->m_lastPositionSecond,
+                       &channelParams->m_lastRelativePosition2D);
+
+    // Step 4: Generate large-scale parameters. All LSPS are uncorrelated.
+    const LargeScaleParameters lsps = GenerateLSPs(channelParams->m_losCondition, table3gpp);
+
+    channelParams->m_DS = lsps.DS;
+    channelParams->m_K_factor = lsps.kFactor;
+
+    // Step 5: Generate Delays and normalize them. Save minTau to be used for channel consistency.
+    double minTau = 100.0;
+    GenerateClusterDelays(lsps.DS, table3gpp, &minTau, &channelParams->m_delay);
+    /* since the scaled Los delays are not to be used in cluster power generation,
+     * we will generate cluster power first and resume to compute Los cluster delay later.*/
+
+    // Step 6: Generate cluster powers.
+    GenerateClusterShadowingTerm(table3gpp, &channelParams->m_clusterShadowing);
+    GenerateClusterPowers(channelParams->m_delay,
+                          lsps.DS,
+                          table3gpp,
+                          channelParams->m_clusterShadowing,
+                          &channelParams->m_clusterPower);
+    double powerMax = 0;
+    const DoubleVector clusterPowerForAngles = RemoveWeakClusters(&channelParams->m_clusterPower,
+                                                                  &channelParams->m_delay,
+                                                                  channelParams->m_losCondition,
+                                                                  table3gpp,
+                                                                  lsps.kFactor,
+                                                                  &powerMax);
+
+    channelParams->m_reducedClusterNumber = channelParams->m_clusterPower.size();
+    // Resume step 5 to compute the delay for LoS condition.
+    if (channelParams->m_losCondition == ChannelCondition::LOS)
+    {
+        AdjustClusterDelaysForLosCondition(&channelParams->m_delay,
+                                           channelParams->m_reducedClusterNumber,
+                                           channelParams->m_K_factor);
     }
-    channelParams->m_alpha = dopplerTermAlpha;
-    channelParams->m_D = dopplerTermD;
+
+    // Step 7: Generate arrival and departure angles for both azimuth and elevation.
+    const auto cPhi = CalculateCphi(channelParams->m_losCondition, table3gpp, lsps.kFactor);
+    const auto cTheta = CalculateCtheta(channelParams->m_losCondition, table3gpp, lsps.kFactor);
+
+    GenerateClusterAngles(channelParams,
+                          clusterPowerForAngles,
+                          powerMax,
+                          cPhi,
+                          cTheta,
+                          lsps,
+                          aMobOrdered,
+                          bMobOrdered,
+                          table3gpp,
+                          &channelParams->m_angle);
+
+    // if blockage enabled, calculate, apply and store attenuation
+    ApplyAttenuationToClusterPowers(&channelParams->m_nonSelfBlocking,
+                                    &channelParams->m_clusterPower,
+                                    &channelParams->m_attenuation_dB,
+                                    channelParams,
+                                    channelParams->m_angle[AOA_INDEX],
+                                    channelParams->m_angle[ZOA_INDEX],
+                                    table3gpp);
+    // Step 8: Coupling of rays within a cluster for both azimuth and elevation
+    // shuffle all the arrays to perform random coupling
+    // Step a): update per-ray angles around cluster means (no shuffling)
+    ComputeRayAngles(channelParams,
+                     table3gpp,
+                     &channelParams->m_rayAoaRadian,
+                     &channelParams->m_rayAodRadian,
+                     &channelParams->m_rayZoaRadian,
+                     &channelParams->m_rayZodRadian);
+
+    // Step b): random coupling by shuffling rays within each cluster
+    RandomRaysCoupling(channelParams,
+                       &channelParams->m_rayAoaRadian,
+                       &channelParams->m_rayAodRadian,
+                       &channelParams->m_rayZoaRadian,
+                       &channelParams->m_rayZodRadian);
+
+    // Step 9: Generate the cross-polarization power ratios
+    // Step 10: Draw initial phases
+    GenerateCrossPolPowerRatiosAndInitialPhases(&channelParams->m_crossPolarizationPowerRatios,
+                                                &channelParams->m_clusterPhase,
+                                                channelParams->m_reducedClusterNumber,
+                                                table3gpp);
+
+    // Generate Doppler terms
+    GenerateDopplerTerms(channelParams->m_reducedClusterNumber,
+                         &channelParams->m_alpha,
+                         &channelParams->m_D);
+
+    // save delay consistency for the channel updates with the reduced cluster number
+    channelParams->m_delayConsistency = channelParams->m_delay;
+    for (uint8_t cInd = 0; cInd < channelParams->m_reducedClusterNumber; cInd++)
+    {
+        // 7.6.3.2, Procedure A, k=0 -> t_0
+        if (channelParams->m_losCondition != ChannelCondition::LOS)
+        {
+            channelParams->m_delayConsistency[cInd] += minTau;
+        }
+        // distance between RX antenna and TX antenna at t_0 in [m] divided by the speed of light
+        // [m/s]
+        channelParams->m_delayConsistency[cInd] += channelParams->m_dis3D / 3e8;
+    }
+
+    FindStrongestClusters(channelParams,
+                          table3gpp,
+                          &channelParams->m_cluster1st,
+                          &channelParams->m_cluster2nd,
+                          &channelParams->m_delay,
+                          &channelParams->m_angle,
+                          &channelParams->m_alpha,
+                          &channelParams->m_D,
+                          &channelParams->m_clusterPower);
+
+    // Precompute angles sincos
+    PrecomputeAnglesSinCos(channelParams, &channelParams->m_cachedAngleSincos);
 
     return channelParams;
 }
 
+void
+ThreeGppChannelModel::UpdateChannelParameters(Ptr<ThreeGppChannelParams> channelParams,
+                                              Ptr<const ChannelCondition> channelCondition,
+                                              Ptr<const MobilityModel> aMob,
+                                              Ptr<const MobilityModel> bMob) const
+{
+    NS_LOG_FUNCTION(this);
+    NS_ASSERT_MSG(channelParams != nullptr, "Channel parameters cannot be null");
+    NS_ASSERT_MSG(channelCondition != nullptr, "Channel condition cannot be null");
+    NS_ASSERT_MSG(aMob != nullptr, "Mobility model A cannot be null");
+    NS_ASSERT_MSG(bMob != nullptr, "Mobility model B cannot be null");
+
+    // Ensure a/b ordering matches the direction used when the params were generated.
+    // This keeps angle/speed associations consistent across reciprocal calls.
+    Ptr<const MobilityModel> aMobOrdered = aMob;
+    Ptr<const MobilityModel> bMobOrdered = bMob;
+    const auto storedIds = channelParams->m_nodeIds;
+    const auto callIds =
+        std::make_pair(aMob->GetObject<Node>()->GetId(), bMob->GetObject<Node>()->GetId());
+    const auto reversedIds = std::make_pair(callIds.second, callIds.first);
+    NS_ASSERT_MSG(storedIds == callIds || storedIds == reversedIds,
+                  "Channel params node ids do not match this link");
+    if (storedIds != callIds)
+    {
+        std::swap(aMobOrdered, bMobOrdered);
+    }
+
+    TrimToBaseClusters(channelParams->m_reducedClusterNumber,
+                       &channelParams->m_delay,
+                       &channelParams->m_angle,
+                       &channelParams->m_cachedAngleSincos,
+                       &channelParams->m_alpha,
+                       &channelParams->m_D,
+                       &channelParams->m_clusterPower);
+
+    UpdateLinkGeometry(aMobOrdered,
+                       bMobOrdered,
+                       &channelParams->m_dis2D,
+                       &channelParams->m_dis3D,
+                       &channelParams->m_endpointDisplacement2D,
+                       &channelParams->m_relativeDisplacement2D,
+                       &channelParams->m_lastPositionFirst,
+                       &channelParams->m_lastPositionSecond,
+                       &channelParams->m_lastRelativePosition2D);
+
+    channelParams->m_txSpeed = aMobOrdered->GetVelocity();
+    channelParams->m_rxSpeed = bMobOrdered->GetVelocity();
+    channelParams->m_losCondition = channelCondition->GetLosCondition();
+    channelParams->m_o2iCondition = channelCondition->GetO2iCondition();
+
+    // Update LSPs for new distance
+    // Update cluster delay (7.6-9, 7.6-10, 7.6-10aa, 7.6-10a)
+    const DoubleVector prevClusterDelay = channelParams->m_delayConsistency;
+    UpdateClusterDelay(&channelParams->m_delay, &channelParams->m_delayConsistency, channelParams);
+
+    // Get the 3GPP parameter table
+    const Ptr<const ParamsTable> table3gpp =
+        GetThreeGppTable(aMobOrdered, bMobOrdered, channelCondition);
+
+    UpdateClusterShadowingTerm(table3gpp,
+                               &channelParams->m_clusterShadowing,
+                               channelParams->m_relativeDisplacement2D);
+    // According to 3GPP 38.901. Procedure A, cluster powers are updated as in Step 6 using the
+    // cluster delays from Equation (7.6-10a).
+
+    GenerateClusterPowers(channelParams->m_delay,
+                          channelParams->m_DS,
+                          table3gpp,
+                          channelParams->m_clusterShadowing,
+                          &channelParams->m_clusterPower);
+
+    // draw random signs from cluster angles +1,-1 and save them to reuse them for the channel
+    // update
+    if (channelParams->m_losCondition != ChannelCondition::LOS &&
+        channelParams->m_clusterXnNlosSign.empty())
+    {
+        GenerateClusterXnNLos(channelParams->m_reducedClusterNumber,
+                              &channelParams->m_clusterXnNlosSign);
+    }
+
+    // Update cluster departure and arrival angles
+    const Double2DVector previousAngles = channelParams->m_angle;
+    UpdateClusterAngles(channelParams, &channelParams->m_angle, prevClusterDelay);
+
+    NS_ABORT_IF(channelParams->m_clusterPower.empty());
+
+    // if blockage enabled, calculate, apply and store attenuation
+    ApplyAttenuationToClusterPowers(&channelParams->m_nonSelfBlocking,
+                                    &channelParams->m_clusterPower,
+                                    &channelParams->m_attenuation_dB,
+                                    channelParams,
+                                    channelParams->m_angle[AOA_INDEX],
+                                    channelParams->m_angle[ZOA_INDEX],
+                                    table3gpp);
+
+    ShiftRayAnglesToUpdatedClusterMeans(table3gpp,
+                                        channelParams,
+                                        previousAngles,
+                                        &channelParams->m_rayAoaRadian,
+                                        &channelParams->m_rayAodRadian,
+                                        &channelParams->m_rayZoaRadian,
+                                        &channelParams->m_rayZodRadian);
+
+    FindStrongestClusters(channelParams,
+                          table3gpp,
+                          &channelParams->m_cluster1st,
+                          &channelParams->m_cluster2nd,
+                          &channelParams->m_delay,
+                          &channelParams->m_angle,
+                          &channelParams->m_alpha,
+                          &channelParams->m_D,
+                          &channelParams->m_clusterPower);
+
+    // Precompute angle sin/cos for efficiency
+    PrecomputeAnglesSinCos(channelParams, &channelParams->m_cachedAngleSincos);
+
+    channelParams->m_generatedTime = Simulator::Now(); // Update timing information
+
+    NS_LOG_DEBUG("Updated channel parameters for consistency (Procedure A): "
+                 << "Clusters: " << channelParams->m_reducedClusterNumber
+                 << ", DS: " << channelParams->m_DS << ", K-factor: " << channelParams->m_K_factor);
+}
+
 Ptr<MatrixBasedChannelModel::ChannelMatrix>
 ThreeGppChannelModel::GetNewChannel(Ptr<const ThreeGppChannelParams> channelParams,
                                     Ptr<const ParamsTable> table3gpp,
-                                    const Ptr<const MobilityModel> sMob,
-                                    const Ptr<const MobilityModel> uMob,
+                                    Ptr<const MobilityModel> sMob,
+                                    Ptr<const MobilityModel> uMob,
                                     Ptr<const PhasedArrayModel> sAntenna,
                                     Ptr<const PhasedArrayModel> uAntenna) const
 {
     NS_LOG_FUNCTION(this);
 
     NS_ASSERT_MSG(m_frequency > 0.0, "Set the operating frequency first!");
+    NS_ASSERT_MSG(channelParams != nullptr, "Channel parameters cannot be null");
+    NS_ASSERT_MSG(sMob != nullptr && uMob != nullptr, "Mobility models cannot be null");
+    NS_ASSERT_MSG(sAntenna != nullptr && uAntenna != nullptr, "Antennas cannot be null");
+    const auto callIds =
+        std::make_pair(sMob->GetObject<Node>()->GetId(), uMob->GetObject<Node>()->GetId());
+    const auto reversedIds = std::make_pair(callIds.second, callIds.first);
+    NS_ASSERT_MSG(channelParams->m_nodeIds == callIds || channelParams->m_nodeIds == reversedIds,
+                  "Channel params node ids do not match this link");
 
     // create a channel matrix instance
     Ptr<ChannelMatrix> channelMatrix = Create<ChannelMatrix>();
